//
//  CellMenuPickerViewController.h
//  Common
//
//  Created by Duncan Groenewald on 23/07/13.
//  Copyright (c) 2013 Duncan Groenewald. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "OSCDStackManager.h"

#define CELLACTION_DELETE          @"Delete"
#define CELLACTION_COPYTOICLOUD    @"Copy to iCloud"
#define CELLACTION_COPYFROMICLOUD  @"Copy to Local"
#define CELLACTION_DOWNLOADFROMICLOUD  @"Download"
#define CELLACTION_SENDEMAIL       @"Send using email"
#define CELLACTION_RESTORE         @"Restore this file"


@protocol CellMenuPickerDelegate <NSObject>
@required
-(void)selectedCellMenu:(NSString*)menu forCell:(UITableViewCell*)cell;
@end

@interface CellMenuPickerViewController : UITableViewController

@property (nonatomic, strong) NSMutableArray *itemTypes;
@property (nonatomic, strong) UITableViewCell *cell;
@property (nonatomic, weak) id<CellMenuPickerDelegate> delegate;

- (id)initWithStyle:(UITableViewStyle)style forCell:(UITableViewCell*)cell type:(NSInteger)type file:(FileRepresentation*) file;
- (id)initWithStyle:(UITableViewStyle)style type:(NSInteger)type;
- (CGSize)getSize;

@end