//
//  OSManagedObject.h
//  CoreDataLibraryApp
//  Abstract: This is the base class from which all NSManagedObject subclasses inherit.  It contains
//  default behaviour such as timestamps.
//
//  Created by Duncan Groenewald on 16/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import <CoreData/CoreData.h>

@interface OSManagedObject : NSManagedObject

@property (nonatomic, retain) NSDate * timestamp;
@property (readonly) NSString * timestampString;

@end

@interface OSManagedObject (PrimitiveAccessors)
- (NSString *)primitiveTimestamp;
- (void)setPrimitiveTimestamp:(NSDate *)newDate;
@end