//
//  PeopleDetailViewController.m
//  CoreDataLibraryApp
//
//  Created by Duncan Groenewald on 13/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import "PeopleDetailViewController.h"

@interface PeopleDetailViewController ()

@end

@implementation PeopleDetailViewController

// Save any changes to the object
- (void)save
{
    //FLOG(@" called.");
    
    [self.detailItem setValue:self.nameTextField.text forKey:@"name"];
    [self.detailItem setValue:self.detailsTextView.text forKey:@"details"];
    
    NSError *error = nil;
    if (![self.managedObjectContext save:&error]) {
        // Replace this implementation with code to handle the error appropriately.
        // abort() causes the application to generate a crash log and terminate. You should not use this function in a shipping application, although it may be useful during development.
        NSLog(@"Unresolved error %@, %@", error, [error userInfo]);
        abort();
    }
    _wasEdited = NO;
}
- (void)setEditable:(BOOL)editable
{
    FLOG(@"setEditable %d called.", editable);
    //set fields to allow/disallow editing
    self.nameTextField.enabled = editable;
    self.detailsTextView.editable = editable;
    self.detailsTextView.allowsEditingTextAttributes = NO;
    // Set flag whenever edit mode is turned on
    // If the view dissapears we check the flag and if its still YES we perform a save
    if (editable) {
        _wasEdited = YES;
    }
}
- (void)configureView
{
    //LOG(@"configureView called.");
    
    [super configureView];
    
    [self displayItem];
}
- (void)displayItem {
    // Update the user interface for the detail item.
    if (self.detailItem) {
        //NSLog(@"Parent name is %@", [[self.detailItem valueForKeyPath:@"parent.displayName"] description]);
        self.nameTextField.text = [self.detailItem valueForKey:@"name"];
        self.detailsTextView.text = [self.detailItem valueForKey:@"details"];
        self.imageView.image = [self.detailItem valueForKey:@"image"];
        self.timestampTextField.text = [self.detailItem valueForKey:@"timestampString"];
        
    } else {
        self.nameTextField.text = @"";
        self.detailsTextView.text = @"";
        self.imageView.image = nil;
        self.timestampTextField.text = @"";
    }
}

@end
